#ifndef INCLUDED_s_ssl_h
#define INCLUDED_s_ssl_h

#include "setup.h"

#ifdef HAVE_SSL

/* OpenSSL includes */
#include <openssl/rsa.h>       
#include <openssl/crypto.h>
#include <openssl/x509.h>
#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
#include "client.h"

#define RANDOM_SIZE 168 /* size of random seed */

extern int ssl_capable;
extern int ssl_cvl;
extern int ssl_svl;
extern char *ssl_cipher_list;
extern char *ssl_pem_passphrase;
extern SSL_CTX* server_ctx;
extern SSL_CTX* client_ctx;
extern SSL_METHOD *server_meth;
extern SSL_METHOD *client_meth;
extern int ssl_init();
extern int ssl_seed_prng(char *filename);
extern int ssl_read(struct Client *, void *, size_t);
extern int ssl_write(struct Client *, const void *, size_t);
extern int ssl_connect(struct Client *);  
extern int ssl_accept(struct Client *, int);
extern int ssl_shutdown(SSL *);
  
#endif /* HAVE_SSL */

#endif /* INCLUDED_s_ssl_h */
