; IRC - Internet Relay Chat, src/i386/irccmp.asm
; Copyright (C) 1990 Jarkko Oikarinen and
;                    University of Oulu, Computing Center
;
; See file AUTHORS in IRC package for additional names of
; the programmers.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 1, or (at your option)
; any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
;
; $Id: irccmp.asm,v 1.2 2002/05/11 01:30:43 smoli Exp $

		global	irccmp

[segment .text]

irccmp:		push	ebx
		push	edi
		push	esi
		push	ecx
                xor     eax, eax
		mov	esi, [esp + 14h]
		mov	edi, [esp + 18h]
		cmp	esi, edi
		jne	.loop
		pop	ecx
		pop	esi
		pop	edi
		pop	ebx
		ret

.loop:		mov	ebx, [esi]
		mov	ecx, [edi]

		test	bl, bl		; byte 0
		jz	.exit_cl
		test	cl, cl
		jz	.exit_bl

		cmp	bl, 'a'
		jb	.b0_nc
		cmp	bl, 'z'
		ja	.b0_ch
		sub	bl, 20h
.b0_ch:		cmp	bl, ''
		jb	.b0_nc
		cmp	bl, ''
		jae	.b0_nc
		sub	bl, 20h
.b0_nc:		cmp	cl, 'a'
		jb	.c0_nc
		cmp	cl, 'z'
		ja	.c0_ch
		sub	cl, 20h
.c0_ch:		cmp	cl, ''
		jb	.c0_nc
		cmp	cl, ''
		jae	.c0_nc
		sub	cl, 20h
.c0_nc:
		cmp	bl, cl
		jne	.exit_bl

		test	bh, bh		; byte 1
		jz	.exit_ch
		test	ch, ch
		jz	.exit_bh
		
		cmp	bh, 'a'
		jb	.b1_nc
		cmp	bh, 'z'
		ja	.b1_ch
		sub	bh, 20h
.b1_ch:		cmp	bh, ''
		jb	.b1_nc
		cmp	bh, ''
		jae	.b1_nc
		sub	bh, 20h
.b1_nc:		cmp	ch, 'a'
		jb	.c1_nc
		cmp	ch, 'z'
		ja	.c1_ch
		sub	ch, 20h
.c1_ch:		cmp	ch, ''
		jb	.c1_nc
		cmp	ch, ''
		jae	.c1_nc
		sub	ch, 20h
.c1_nc:
		cmp	bh, ch
		je	.rotate

.exit_cl:	movzx	eax, cl
		xor	ecx, ecx
		jz	.exit
.exit_bl:	movzx	eax, bl
		jmp	.exit
.exit_bh:	movzx	eax, bh
		jmp	.exit
.exit_ch:	movzx	eax, ch
.exit:
		pop	ecx
		pop	esi
		pop	edi
		pop	ebx
		ret

.rotate:	ror	ebx, 10h
		ror	ecx, 10h

		test	bl, bl		; byte 2
		jz	.exit_cl
		test	cl, cl
		jz	.exit_bl

		cmp	bl, 'a'
		jb	.b2_nc
		cmp	bl, 'z'
		ja	.b2_ch
		sub	bl, 20h
.b2_ch:		cmp	bl, ''
		jb	.b2_nc
		cmp	bl, ''
		jae	.b2_nc
		sub	bl, 20h
.b2_nc:		cmp	cl, 'a'
		jb	.c2_nc
		cmp	cl, 'z'
		ja	.c2_ch
		sub	cl, 20h
.c2_ch:		cmp	cl, ''
		jb	.c2_nc
		cmp	cl, ''
		jae	.c2_nc
		sub	cl, 20h
.c2_nc:
		cmp	bl, cl
		jne	.exit_bl

		test	bh, bh		; byte 3
		jz	.exit_ch
		test	ch, ch
		jz	.exit_bh
		
		cmp	bh, 'a'
		jb	.b3_nc
		cmp	bh, 'z'
		ja	.b3_ch
		sub	bh, 20h
.b3_ch:		cmp	bh, ''
		jb	.b3_nc
		cmp	bh, ''
		jae	.b3_nc
		sub	bh, 20h
.b3_nc:		cmp	ch, 'a'
		jb	.c3_nc
		cmp	ch, 'z'
		ja	.c3_ch
		sub	ch, 20h
.c3_ch:		cmp	ch, ''
		jb	.c3_nc
		cmp	ch, ''
		jae	.c3_nc
		sub	ch, 20h
.c3_nc:
		cmp	bh, ch
		jne	.exit_bh

		add	esi, 04h
		add	edi, 04h
		jmp	.loop
