/************************************************************************
 *   IRC - Internet Relay Chat, src/m_broadcast.c
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   See file AUTHORS in IRC package for additional names of
 *   the programmers. 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: m_broadcast.c,v 1.1 2002/05/22 11:07:10 smoli Exp $
 */

#include "client.h"
#include "numeric.h"
#include "ircd.h"
#include "s_user.h"
#include "send.h"

#include <string.h>

/*
 * m_broadcast()
 *
 * parv[0] = sender prefix
 * parv[1] = new hostname
 *
 */
int m_broadcast(struct Client *cptr,
                struct Client *sptr,
                int parc,
                char *parv[])
{
  if(MyConnect(sptr))
    { 
      if(!IsOper(sptr) && !IsServer(cptr))
        {
          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
          return 0;
        }
  
      if(parc < 2)
        {
          sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
                     me.name, parv[0], "BROADCAST");
          return 0;
        }
    }
  
  sendto_serv_butone(cptr, ":%s BROADCAST :%s", parv[0], parv[1]);
  sendto_myclients(sptr, parv[1]);
  
  return 1;
}
