/************************************************************************
 *   IRC - Internet Relay Chat, src/m_spoof.c
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   See file AUTHORS in IRC package for additional names of
 *   the programmers. 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  $Id: m_spoof.c,v 1.4 2002/05/23 16:06:25 shifty Exp $
 */

#include "client.h"
#include "numeric.h"
#include "ircd.h"
#include "s_user.h"
#include "send.h"

#include <string.h>

/*
 * m_spoof()
 *
 * parv[0] = sender prefix
 * parv[1] = new hostname
 *
 */
int     m_spoof(struct Client *cptr,
                struct Client *sptr,
                int parc,
                char *parv[])
{
  if(MyConnect(sptr))
    { 
      if(!IsOper(sptr) && !IsServer(cptr))
        {
          sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
          return 0;
        }
  
      if(parc < 2)
        {
          sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
                     me.name, parv[0], "SPOOF");
          return 0;
        }
  
      if(sptr->user->spoofed)
        {
          sendto_one(sptr, ":%s NOTICE %s :You already spoofed your hostname.", me.name, parv[0]);
          return 0;
        }
      
      if(!valid_hostname(parv[1]))
        {
          sendto_one(sptr, ":%s NOTICE %s :'%s' is not a valid hostname", me.name, parv[0], parv[1]);
          return 0;
        }
      
    }
  
#ifdef SPOOF_NOTICE    
  sendto_realops("Spoofing hostname '%s' for user %s [%s@%s]",
                 parv[1], sptr->name, sptr->username, sptr->host);
#endif  
  
  sendto_serv_butone(cptr, ":%s SPOOF :%s", parv[0], parv[1]);
  
  strncpy(sptr->host, parv[1], HOSTLEN);
  sptr->host[HOSTLEN] = '\0';
  sptr->user->spoofed++;
  
  return 1;
}
