#include <stdio.h>
#include <string.h>
#include <sys/time.h>

#include "irc_string.h"

struct timezone tz = { 0, 0 };
unsigned long stamp = 0;
struct timeval tv;

void profile_start()
{
  gettimeofday(&tv, &tz);
  stamp = tv.tv_usec + tv.tv_sec * 1000000;
}

void profile_end(const char *function, const void *buf, unsigned long size, unsigned long bytes)
{
  unsigned long current;
  unsigned long delta;
  
  gettimeofday(&tv, &tz);
  current = tv.tv_usec + tv.tv_sec * 1000000;
  delta = current - stamp;
  
  fprintf(stderr, "function: %s buf: %p size: %lu retval: %lu time: %lu usecs\n",
          function, buf, size, bytes, delta);
}

int main()
{
  FILE *f;
  char buf[131072];
  char buf2[131072];
  int l1, l2;
  
  f = fopen("/etc/services", "r");
  
  l1 = fread(buf, 100000, 1, f);
  rewind(f);
  fread(buf2, 100000, 1, f);
  
  profile_start();
  l2 = irclen(&buf[1]);
  profile_end("irclen()", buf, l1, l2);

  profile_start();
  l2 = irccmp(&buf[1], &buf2[1]);
  profile_end("irccmp()", buf2, l1, l2);

  profile_start();
  l2 = ircncmp(&buf[1], &buf2[1], 1000000);
  profile_end("ircncmp()", buf2, l1, l2);

  printf("%d %d\n", !irccmp("TESTLINE", ""), strcmp("TESTLINE", ""));
  return 0;
}
